/*
 
 	ZLOIND
 	 
 	The circuit:
 	 
 	* 2 LED;
 	* 1 Speaker;
 	* 1 Potentiometer
 
 	Reads from the serial port different kinds of ASCII values, then it
 	turns on the leds and emits a sound with the speaker, according to
 	various combinations made by the ASCII value.
 
 	created by syxanash
 	syxanash[-at-]gmail[-dot-]com
 
 	This code is released under the terms of the GNU/GPL license version 3
 
*/

#define NOTE4  262
#define NOTE5  523
#define NOTE6  784
#define NOTE7  1045

int data = 0;

int speaker   = 9;
int green_led = 7;
int red_led   = 6;

void setup()
{
  Serial.begin(9600); 
  pinMode(green_led,OUTPUT);
  pinMode(red_led,OUTPUT);
}

void loop()
{
  if(Serial.available() != 0)
  {
    data = Serial.read();

    // free networks
    if (data == 111)
    {
      digitalWrite(green_led,HIGH);

      free_tone();

      digitalWrite(green_led,LOW);
    }

    // closed networks
    if (data == 119)
    {
      digitalWrite(red_led,HIGH);

      closed_tone();

      digitalWrite(red_led,LOW);
    }

    // error messages
    if (data == 101)
    {
      error_tone();
      
      for ( int i = 0; i < 2; i++ ) {
        digitalWrite(red_led, HIGH);
        digitalWrite(green_led, HIGH);
  
        error_tone();
  
        digitalWrite(red_led, LOW);
        digitalWrite(green_led, LOW);
      }
    }
  }
}

void error_tone()
{
  tone(speaker,NOTE7,0);
  delay(120);
  tone(speaker,NOTE7,0);
  delay(120);
  tone(speaker,NOTE5,0);
  delay(120);
  noTone(speaker);
}

void free_tone()
{
  tone(speaker,NOTE4,0);
  delay(120);
  tone(speaker,NOTE5,0);
  delay(120);
  tone(speaker,NOTE6,0);
  delay(120);
  noTone(speaker);
}

void closed_tone()
{
  tone(speaker,NOTE4,0);
  delay(120);
  tone(speaker,NOTE5,0);
  delay(120);
  tone(speaker,NOTE4,0);
  delay(120);
  noTone(speaker);
}
